package cn.ibizlab.core.extensions.domain;

import cn.ibizlab.core.extensions.util.IEntityActionHelper;
import cn.ibizlab.util.helper.RuleUtils;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import lombok.Data;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Hashtable;
import java.util.List;
import java.util.concurrent.ConcurrentHashMap;

@JsonIgnoreProperties(ignoreUnknown = true)
 @Data
public class BaseEntity extends ConcurrentHashMap implements IEntity {

    public String KEY;
    public String ENTITYNAME;


    public String KEYFIELDNAME;

    public BaseEntity FACTENTITY;
    public BaseEntity getFACTENTITY()
    {
        return FACTENTITY;
    }
    public void setFACTENTITY(BaseEntity FACTENTITY)
    {
        this.FACTENTITY = FACTENTITY;
    }

    @Override
    public String toString()
    {
        return "";
    }
   
    
    public BaseEntity findRoot(String key)
    {
        if(key.equalsIgnoreCase("root")&&super.containsKey("rootentity"))
        {
            return (BaseEntity)super.get("rootentity");
        }
        return null;
    } 

    public void regesitAttr(String key,BaseEntity val)
    {
        if(key.equalsIgnoreCase("root")&& !super.containsKey("rootentity"))
            super.put("rootentity", val);
    }

    private IEntityActionHelper iEntityActionHelper = null;

    public static BaseEntity createEntity(String factentity,BaseEntity item)
    {
        try
        {
            BaseEntity bt=(BaseEntity)Class.forName("net.ibizsys.dst.common.domain."+factentity).newInstance();
            bt.putAll(item);
            bt.regesitAttr("root", bt);
            return bt;
        }catch (Exception ex)
        {
            BaseEntity bt=new BaseEntity();
            bt.putAll(item);
            bt.regesitAttr("root", bt);
            return bt;
        }

    }
    private  BaseField nullFiled=new BaseField();
    @Override
    public IField $(String key)
    {
        if(StringUtils.isEmpty(key))
            return nullFiled;
        

        Object obj=this.get(key);
        if(obj instanceof  IField)
        {
            IField f= (IField)obj;
            if(f.getValue()!=null&&key.indexOf(".")>0)
            {
                String[] arr=key.split("[.]");
                if(arr.length>=2)
                {
                    if((!StringUtils.isEmpty(arr[0]))&&(!StringUtils.isEmpty(arr[1])))
                    {
                        f.setEntity(arr[0]);
                        f.setField(arr[1]);
                    }
                }
            }
            return f;
        }     
        else
            return nullFiled;
    }
    @Override
    public Double $D(String key)
    {
        IField field=this.$(key);
        Object val=field.getValue();
        if(val==null)
            return 0d;
        else if((val instanceof Integer)||(val instanceof Double)||(val instanceof Long)||(val instanceof BigDecimal)||(val instanceof BigInteger)||(val instanceof Float))
            return (double)val;

        return 1d;
    }

    @Override
    public boolean IF(String cond)
    {
        return test(cond);
    }
 
    public boolean isDel(String members)
    { 
        String[] arr=members.split("[.]");
        if(arr.length>=2&&(!StringUtils.isEmpty(arr[0])))
        {

            if(this.get(arr[0]+".SFSC")!=null)
            {
                if(this.get(arr[0]+".SFSC").toString().equals("Y")||this.get(arr[0]+".SFSC").toString().equals("1"))
                {
                    return true;
                }
            }
        }
       
        return false;
    }

    @Override
    public boolean test(String cond)
    {
        String[] arr=cond.split("\\s+");
        String option="";
        String members="";
        String exp="";
        if(arr.length>=2)
        {
            members=arr[0];
            option=arr[1];
        }


        String[] ms=members.split("[.]");
        if(ms.length>=2&&(!StringUtils.isEmpty(ms[0])))
        {
            Object sub=this.get(ms[0]);
            if(sub!=null&& sub instanceof BaseEntityList)
            {
               return ((BaseEntityList)sub).test(cond);
            }
        }

        if(arr.length>=3)
        {
            exp=arr[2];
            if(exp.startsWith("%"))
            {
                if(isDel(members))
                {
                    return false;
                }
                return test(this, members, option, execFunc(exp));
            }
        }
        
        if(isDel(members))
        {
            return false;
        }
        return test(this, members, option, exp);
    }

    private Object execFunc(String exp)
    {
        Object rt=null;
        exp=exp.replace("%", "").trim();
        if(exp.startsWith("DAY("))
        { 
            Calendar calendar = Calendar.getInstance();  
            String quStr=exp.substring(exp.indexOf("(")+1,exp.indexOf(")"));
            quStr=quStr.replace("+","").trim();
            int day=0;
            if(!StringUtils.isEmpty(quStr)){
                day= Integer.parseInt(quStr);
            }

            calendar.add(Calendar.DATE, day);
            return new Timestamp(calendar.getTime().getTime());
        }
        else if(exp.endsWith(")"))
        {

            String quStr=exp.substring(exp.indexOf("(")+1,exp.indexOf(")"));

            exp = exp.substring(0,exp.indexOf("(")).trim();
            quStr=quStr.replace("+","").trim();
            Integer day=0;
            if(!StringUtils.isEmpty(quStr)){
                day=  Integer.parseInt(quStr);
            }


            Object val=null;
            if(this.findRoot("root")!=null)
                val= this.findRoot("root").$(exp).getValue();
            else
                val= this.$(exp).getValue();

            if(val!=null)
            {
                if(val instanceof Timestamp)
                {
                    Calendar calendar = Calendar.getInstance();
                    calendar.setTime((Timestamp)val);
                    calendar.add(Calendar.DATE, day);
                    return new Timestamp(calendar.getTime().getTime());
                }
                else if(val instanceof Integer)
                {
                    return (int)val+day;
                }
                else if(val instanceof BigDecimal)
                {
                    return ((BigDecimal)val).intValue()+day;
                }
            }

            return val;

        }
        if(this.findRoot("root")!=null)
            return this.findRoot("root").$(exp).getValue();
        return this.$(exp).getValue();
    }

    public static boolean test(BaseEntity object,String members,String option,Object exp)
    {
        Object obj=object.getObj(members);
        if(obj==null)
            obj=new BaseField();
        if(!(obj instanceof IField))
            return false;
        IField field=(IField)obj;
        if(option.equalsIgnoreCase("eq")||option.equalsIgnoreCase("equal")||option.equalsIgnoreCase("="))
            return field.EQ(exp);
        else if (option.equalsIgnoreCase("noteq")||option.equalsIgnoreCase("notequal")||option.equalsIgnoreCase("<>")||option.equalsIgnoreCase("!="))
            return field.NOTEQ(exp);
        else if (option.equalsIgnoreCase("gt")||option.equalsIgnoreCase(">"))
            return field.GT(exp);
        else if (option.equalsIgnoreCase("lt")||option.equalsIgnoreCase("<"))
            return field.LT(exp);
        else if (option.equalsIgnoreCase("gtandeq")||option.equalsIgnoreCase("ge")||option.equalsIgnoreCase(">="))
            return field.GTANDEQ(exp);
        else if (option.equalsIgnoreCase("ltandeq")||option.equalsIgnoreCase("le")||option.equalsIgnoreCase("<="))
            return field.LTANDEQ(exp);
        else if (option.equalsIgnoreCase("null")||option.equalsIgnoreCase("isnull"))
            return field.ISNULL(exp);
        else if (option.equalsIgnoreCase("notnull")||option.equalsIgnoreCase("isnotnull"))
            return field.ISNOTNULL(exp);
        else if (option.equalsIgnoreCase("like")||option.equalsIgnoreCase("matchor"))
            return field.LIKE(exp.toString());
        else if (option.equalsIgnoreCase("leftlike")||option.equalsIgnoreCase("startswith"))
            return field.LEFTLIKE(exp.toString());
        else if (option.equalsIgnoreCase("rightlike")||option.equalsIgnoreCase("endswith"))
            return field.RIGHTLIKE(exp.toString());
        else if (option.equalsIgnoreCase("match")||option.equalsIgnoreCase("matchand")||option.equalsIgnoreCase("matches"))
            return field.MATCHES(exp.toString());
        else if (option.equalsIgnoreCase("in"))
            return field.IN(exp.toString());
        else if (option.equalsIgnoreCase("notin"))
            return field.NOTIN(exp.toString());

        else if (option.equalsIgnoreCase("inc2s"))
            return field.INC2S(exp.toString());
        else if (option.equalsIgnoreCase("notinc2s"))
            return field.NOTINC2S(exp.toString());

        else if (option.equalsIgnoreCase("NOTLIKE"))
            return field.NOTLIKE(exp.toString());
        else if (option.equalsIgnoreCase("LEFTNOTLIKE"))
            return field.LEFTNOTLIKE(exp.toString());
        else if (option.equalsIgnoreCase("RIGHTNOTLIKE"))
            return field.RIGHTNOTLIKE(exp.toString());
        else if (option.equalsIgnoreCase("NOTMATCHES"))
            return field.NOTMATCHES(exp.toString());
        else
            return false;
    }

    @Override
    public void setActionHelper(IEntityActionHelper iEntityActionHelper) {
        this.iEntityActionHelper = iEntityActionHelper;
    }

    @Override
    public IEntityActionHelper getActionHelper()
    {
        if (this.iEntityActionHelper == null ) {
            return  null;
        }
        return this.iEntityActionHelper;
    }

    @Override
    public List<BaseEntity> selectRow(String dblink,String sql)
    {
        return this.getActionHelper().select(dblink,sql);
    }

    
    public void onFillObj(Object key)
    {
        
        if(key.toString().equalsIgnoreCase(this.ENTITYNAME))
        {
            if(this.getFACTENTITY()==null)
                this.set(key.toString(), this);
            else
                this.set(key.toString() ,this.getFACTENTITY());
            return ;
        }
        DSTEntityModel entityModel =this.getActionHelper().getModel(this.ENTITYNAME);
        DSTEntityModel refmodel =this.getActionHelper().getModel(key.toString());
        if (refmodel!=null&&entityModel!=null&&entityModel.getLookups().containsKey(key.toString()))
        {
            this.getRow(refmodel.getDblink(),key.toString(),refmodel.getSqltable(),entityModel.getLookups().get(key.toString()).getSelectCondition(),entityModel.getLookups().get(key.toString()).getParamsCondition());
        }
        else{
            BaseEntity ret=new BaseEntity();
            this.put(key,ret);

        }
    }
    private Object objLock=new Object();
    private Hashtable<Object,Integer> filled=new Hashtable<Object,Integer>();


    @Override
    public IEntity $E(String key) {
        synchronized (objLock)
        {
            if(!filled.containsKey(key))
            {
//                if(!StringUtils.isEmpty(CodeListBase.getCodeListText("DST_CLEntityCodeList",key.toString())))
//                    this.onFillObj(key);
                

                filled.put(key,1);
            }
        }
        Object val=super.get(key);
        
        if(val instanceof IEntity)
            return (IEntity)val;
        else if(val!=null&&val.getClass().isArray()){
            BaseEntityList list=new BaseEntityList();

            List<BaseEntity> acts=(ArrayList)val;
            if(acts.size()==1)
            {
                this.put(key,acts.get(0));
                return acts.get(0);
            }
            for(BaseEntity item : acts)
                list.add(item);

            this.put(key, list);
        }
        else{
            val = new BaseEntity(); 
            this.put(key, val);
        }
        return (IEntity)val;

    }
    @Override
    public Object get(Object key) {

        if(key.toString().indexOf(".")>0)
            return this.getObj(key.toString());



        synchronized (objLock)
        {
            if(!filled.containsKey(key))
            {
//                if(!StringUtils.isEmpty(CodeListBase.getCodeListText("DST_CLEntityCodeList",key.toString())))
//                    this.onFillObj(key);
                

                filled.put(key,1);
            }
        }

        Object val=super.get(key);
        if(val instanceof IField)
            return val;
        else if(val instanceof IEntity)
            return val;
        else if(val!=null&&val.getClass().isArray()){
            BaseEntityList list=new BaseEntityList();

            List<BaseEntity> acts=(ArrayList)val;
            if(acts.size()==1)
            {
                this.put(key,acts.get(0));
                return acts.get(0);
            }
            for(BaseEntity item : acts)
                list.add(item);

            this.put(key, list);
        }
        else{
            BaseField field=new BaseField();
            field.setValue(val);
            this.put(key, field);
        }
        return val;
    }

    @Override
    public Object put(Object key, Object val) {

        if(val instanceof IField)
            return super.put(key, val);
        else if(val instanceof IEntity) {
            ((IEntity) val).setENTITYNAME(key.toString());
            ((IEntity) val).regesitAttr("root", this.findRoot("root"));
            return super.put(key, val);
        }
        else if(val!=null&&val.getClass().isArray()){
            BaseEntityList list=new BaseEntityList();
            List<BaseEntity> acts=(ArrayList)val;
            if(acts.size()==1)
            {
                acts.get(0).setENTITYNAME(key.toString());
                acts.get(0).regesitAttr("root",this.findRoot("root"));
                return super.put(key,acts.get(0));
            }
            for(BaseEntity item : acts)
            {
                item.setENTITYNAME(key.toString());
                item.regesitAttr("root",this.findRoot("root"));
                list.add(item);
            }

            list.setENTITYNAME(key.toString());
            list.regesitAttr("root",this.findRoot("root"));
            return super.put(key, list);
        }
        else
        {
            BaseField field=new BaseField();
            field.setValue(val);
            return super.put(key, field);
        }

    }



    public void putEntity(String key,BaseEntity val) {
        if (val == null) {
            return;
        }

        synchronized (objLock) {
            if (!filled.containsKey(key)) {

                this.put(key, val);
                filled.put(key, 1);
                return;
            }
        }
    }


    public void addEntity(String key,BaseEntity val)
    {
        if (val==null)
        {
            return;
        }
        val.setENTITYNAME(key);
        val.regesitAttr("root",this.findRoot("root"));
        synchronized (objLock)
        {
            if(!filled.containsKey(key))
            { 
               
                this.put(key, val);
                filled.put(key,1);
                return ;
            }
        }


        
        Object obj=super.get(key);
        if(obj instanceof BaseEntity)
        {
            BaseEntityList list=new BaseEntityList();
            list.add((BaseEntity)obj);
            list.add(val);
            list.setENTITYNAME(key);
            list.regesitAttr("root",this.findRoot("root"));
            this.put(key,list);
        }
        else if(obj instanceof BaseEntityList)
        {
            ((BaseEntityList)obj).add(val);
        }
        else
        {
            this.put(key, val);
        }
    }

    public Object set(Object key, Object val)
    {
        return this.put(key,val);
    }
    public Object getObj(String key)
    {
        return RuleUtils.getObj(this,key);
    }

    public Object getRow(String dblink,String itemkey,String selectcommand,String lookupcond,List<String> lookupkeys)
    {

        if(StringUtils.isEmpty(selectcommand))
            selectcommand="select * from " + itemkey + " where 1=1 ";

        List<String> params=new ArrayList<String>();
        for(String lookupkey:lookupkeys)
        {
            Object key=this.getObj(lookupkey);
            if((key instanceof IField))
            {
                params.add(((IField) key).getCondValue());
            }
            else
                params.add("null");
        }

        List<BaseEntity> list= this.selectRow( dblink,selectcommand+String.format(lookupcond,params.toArray()));



        if(list==null||list.size()==0)
        {
            BaseEntity ret=new BaseEntity();
            this.put(itemkey,ret);
            return ret;
        }
        else if(list.size()==1)
        {
            this.put(itemkey,list.get(0));
            return list.get(0);
        }
        else
        {
            BaseEntityList rt=new BaseEntityList();

            for(BaseEntity item : list)
            {
                item.setENTITYNAME(itemkey); 
                item.regesitAttr("root",this.findRoot("root"));
                rt.add(item);
            }
             

            this.put(itemkey, rt);
            return rt;
        }




    }
 
}