package cn.ibizlab.core.extensions.domain;

import cn.ibizlab.core.extensions.util.IEntityActionHelper;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import lombok.Data;
import org.springframework.util.StringUtils;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;

@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class BaseEntityList extends ArrayList<BaseEntity> implements IEntity {

    public String KEY;
    public String ENTITYNAME;
    private  BaseField nullFiled=new BaseField();

    private BaseEntity root;

    public void regesitAttr(String key,BaseEntity val)
    {
        if(key.equalsIgnoreCase("root")&&root==null)
            root=val;
    }

    @Override
    public IEntity $E(String key) {
        return new BaseEntity();
    }
    @Override
    public Object get(Object key) {

        if(key instanceof  Integer)
            return  super.get((int)key);
        BaseFieldList list=new BaseFieldList();

        for(BaseEntity item:this)
        {
            Object val=item.get(key);
            if(val instanceof BaseField)
                list.add((BaseField)val);
        }
        if(list.size()==1)
            return list.get(0);
        else if(list.size()==0)
            return nullFiled;
        else
            return list;
    }


    @Override
    public IField $(String key)
    {
        if(StringUtils.isEmpty(key))
            return nullFiled;
        

        Object obj=this.get(key);
        if(obj instanceof  IField)
        {
            IField f= (IField)obj;
            if(f.getValue()!=null&&key.indexOf(".")>0)
            {
                String[] arr=key.split("[.]");
                if(arr.length>=2)
                {
                    if((!StringUtils.isEmpty(arr[0]))&&(!StringUtils.isEmpty(arr[1])))
                    {
                        f.setEntity(arr[0]);
                        f.setField(arr[1]);
                    }
                }
            }
            return f;
        }     
        else
            return nullFiled;
    }
    @Override
    public Double $D(String key)
    {
        IField field=this.$(key);
        Object val=field.getValue();
        if(field instanceof BaseFieldList)
            val=((BaseFieldList) field).get(0);
        if(val==null)
            return 0d;
        else if((val instanceof Integer)||(val instanceof Double)||(val instanceof Long)||(val instanceof BigDecimal)||(val instanceof BigInteger)||(val instanceof Float))
            return (double)val;

        return 1d;
    }
    @Override
    public boolean IF(String cond)
    {
        return test(cond);
    }

    @Override
    public boolean test(String cond)
    {
         
        {
            for(BaseEntity obj:this)
            {
                obj.setENTITYNAME(this.ENTITYNAME);
                if(obj.test(cond))
                    return true;
            }
            return false;
        }
       
    }

    private IEntityActionHelper iEntityActionHelper = null;

    @Override
    public void setActionHelper(IEntityActionHelper iEntityActionHelper) {
        this.iEntityActionHelper = iEntityActionHelper;
    }

    @Override
    public IEntityActionHelper getActionHelper()
    {
        if (this.iEntityActionHelper == null ) {
            return  null;
        }
        return this.iEntityActionHelper;
    }

    @Override
    public List<BaseEntity> selectRow(String dblink,String sql)
    {
        return (BaseEntityList)this.getActionHelper().select(dblink,sql);
    }

}