package cn.ibizlab.core.extensions.domain;

import cn.ibizlab.util.helper.RuleUtils;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import lombok.Data;
import org.springframework.util.ObjectUtils;
import java.io.BufferedReader;
import java.io.Reader;
import java.math.BigDecimal;
import java.math.BigInteger;

@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class BaseField  implements IField {
    private String field;
    private String entity;
    private Object value=null;
    public void setValue(Object value)
    {

        if(value instanceof  java.sql.Clob)
        {
            // Clob类型 转String
            BufferedReader br =null;
            Reader is = null;
            try {
                String reString = "";
                is = ((java.sql.Clob)value).getCharacterStream();
                br = new BufferedReader(is);
                String s = br.readLine();
                StringBuffer sb = new StringBuffer();
                while (s != null) {
                    sb.append(s);
                    s = br.readLine();
                }
                reString = sb.toString();

                this.value=reString;
            }
            catch (Exception ex)
            {

            }
            finally {
                try
                {
                    if(br!=null){
                        br.close();
                    }
                }
                catch (Exception ex)
                {}
                try
                {
                    if(is!=null){
                        is.close();
                    }
                }
                catch (Exception ex)
                {}

            }

        }
        else
            this.value=value;
    }
    public Object getValue()
    {
        return this.value;
    }

    @Override
    public String getCondValue() {
        Object val=getValue();
        if(ObjectUtils.isEmpty(val))
            return "null";
        String str="";
        if((val instanceof Integer)||(val instanceof Double)||(val instanceof Long)||(val instanceof BigDecimal)||(val instanceof BigInteger)||(val instanceof Float))
            str=val.toString();
        else
            str="'"+val.toString()+"'";
        return str;
    }

    @Override
    public Object getFecthValue() {
        return getValue();
    }

    public static BaseField from(Object value)
    {
        BaseField field=new BaseField();
        field.setValue(value);
        return field;
    }
    @Override
    public boolean EQ(Object val) {
        return RuleUtils.equal(val, this.value);
    }

    @Override
    public boolean NOTEQ(Object val) {
        return !RuleUtils.equal(val, this.value);
    }

    @Override
    public boolean GTANDEQ(Object val) {
        return RuleUtils.ge(val,this.value);
    }

    @Override
    public boolean GT(Object val) {
        return RuleUtils.gt(val, this.value);
    }

    @Override
    public boolean LTANDEQ(Object val) {
        return RuleUtils.le(val,this.value);
    }

    @Override
    public boolean LT(Object val) {
        return RuleUtils.lt(val,this.value);
    }

    @Override
    public boolean ISNULL(Object val) {
        return RuleUtils.isNull(this.value);
    }

    @Override
    public boolean ISNOTNULL(Object val) {
        return RuleUtils.isNotNull(this.value);
    }

    @Override
    public boolean LIKE(String val) {
        return RuleUtils.matchor(val, this.value);
    }

    @Override
    public boolean LEFTLIKE(String val) {
        return RuleUtils.leftmatchor(val, this.value);
    }

    @Override
    public boolean RIGHTLIKE(String val) {
        return RuleUtils.rightmatchor(val, this.value);
    }

    @Override
    public boolean IN(String val) {
        return RuleUtils.in(val, this.value);
    }

    @Override
    public boolean NOTIN(String val) {
        return RuleUtils.notin(val, this.value);
    }

    @Override
    public boolean INC2S(String val) {
        return RuleUtils.inc2s(val, this.value);
    }

    @Override
    public boolean NOTINC2S(String val) {
        return RuleUtils.notinc2s(val, this.value);
    }

    @Override
    public boolean MATCHES(String val) {
        return RuleUtils.matchand(val, this.value);
    }

    @Override
    public String toString()
    {
        if(ObjectUtils.isEmpty(this.getValue()))
            return "";
        else
            return this.getValue().toString();
    }
 

    @Override
    public boolean NOTLIKE(String val) {
        return !LIKE(val);
    }

    @Override
    public boolean LEFTNOTLIKE(String val) {
        return !LEFTLIKE(val);
    }

    @Override
    public boolean RIGHTNOTLIKE(String val) {
        return !RIGHTLIKE(val);
    }

    @Override
    public boolean NOTMATCHES(String val) {
        return !MATCHES(val);
    }

}