package cn.ibizlab.core.extensions.domain;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import lombok.Data;
import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Hashtable;

@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class BaseFieldList extends ArrayList<BaseField>  implements IField {
    private String field;
    private String entity;
    public Object getValue()
    {
        String rt="";
        Hashtable<Object,Integer> setcheck=new Hashtable<Object, Integer>();
        if(this.size()==0)
            return null;
        if(this.size()==1)
            return this.get(0).getValue();
        Object sObj=null;
        for(BaseField obj:this)
        {
            Object val=obj.getValue();
            if(ObjectUtils.isEmpty(val))
                continue;
            if(setcheck.containsKey(val))
                continue;
            else
                setcheck.put(val,1);
            String str=val.toString();
            sObj=val;
            if(!StringUtils.isEmpty(rt))
                rt=rt+",";
            rt=rt+str;
        }
        if(StringUtils.isEmpty(rt))
            rt=null;
        if(setcheck.size()==1)
            return sObj;

        return rt;
    }

    @Override
    public String getCondValue() {
        String rt="";
        Hashtable<Object,Integer> setcheck=new Hashtable<Object, Integer>();
        for(BaseField obj:this)
        {
            Object val=obj.getValue();
            if(ObjectUtils.isEmpty(val))
                continue;
            if(setcheck.containsKey(val))
                continue;
            else
                setcheck.put(val,1);
            String str="";
            if((val instanceof Integer)||(val instanceof Double)||(val instanceof Long)||(val instanceof BigDecimal)||(val instanceof BigInteger)||(val instanceof Float))
                str=val.toString();
            else
                str="'"+val.toString()+"'";
            if(!StringUtils.isEmpty(rt))
                rt=rt+",";
            rt=rt+str;
        }
        if(StringUtils.isEmpty(rt))
            rt="null";

        return rt;
    }

    @Override
    public Object getFecthValue() {
        return null;
    }

    @Override
    public boolean EQ(Object val) {
        for(BaseField obj:this)
            if(obj.EQ(val))
                return true;
        return false;
    }

    @Override
    public boolean NOTEQ(Object val) {
        return !EQ(val);
    }

    @Override
    public boolean GTANDEQ(Object val) {
        for(BaseField obj:this)
            if(obj.GTANDEQ(val))
                return true;
        return false;
    }

    @Override
    public boolean GT(Object val) {
        for(BaseField obj:this)
            if(obj.GT(val))
                return true;
        return false;
    }

    @Override
    public boolean LTANDEQ(Object val) {
        for(BaseField obj:this)
            if(obj.LTANDEQ(val))
                return true;
        return false;
    }

    @Override
    public boolean LT(Object val) {
        for(BaseField obj:this)
            if(obj.LT(val))
                return true;
        return false;
    }

    @Override
    public boolean ISNULL(Object val) {
        for(BaseField obj:this)
            if(obj.ISNULL(val))
                return true;
        return false;
    }

    @Override
    public boolean ISNOTNULL(Object val) {
        return !ISNULL(val);
    }

    @Override
    public boolean LIKE(String val) {
        for(BaseField obj:this)
            if(obj.LIKE(val))
                return true;
        return false;
    }

    @Override
    public boolean LEFTLIKE(String val) {
        for(BaseField obj:this)
            if(obj.LEFTLIKE(val))
                return true;
        return false;
    }

    @Override
    public boolean RIGHTLIKE(String val) {
        for(BaseField obj:this)
            if(obj.RIGHTLIKE(val))
                return true;
        return false;
    }

    @Override
    public boolean IN(String val) {
        for(BaseField obj:this)
            if(obj.IN(val))
                return true;
        return false;
    }

    @Override
    public boolean NOTIN(String val) {
        return !IN(val);
    }

    @Override
    public boolean INC2S(String val) {
        for(BaseField obj:this)
            if(obj.INC2S(val))
                return true;
        return false;
    }

    @Override
    public boolean NOTINC2S(String val) {
        return !INC2S(val);
    }

    @Override
    public boolean MATCHES(String val) {
        for(BaseField obj:this)
            if(obj.MATCHES(val))
                return true;
        return false;
    }

    @Override
    public String toString()
    {
        if(ObjectUtils.isEmpty(this.getValue()))
            return "";
        else
        {
            String rt="";
            for(BaseField obj:this)
            {
                Object val=obj.getValue();
                if(ObjectUtils.isEmpty(val))
                    continue;
                String str=val.toString();

                if(!StringUtils.isEmpty(rt))
                    rt=rt+",";
                rt=rt+str;
            }
            if(StringUtils.isEmpty(rt))
                rt="";

            return rt;
        }
    }

    @Override
    public boolean NOTLIKE(String val) {
        return !LIKE(val);
    }

    @Override
    public boolean LEFTNOTLIKE(String val) {
        return !LEFTLIKE(val);
    }

    @Override
    public boolean RIGHTNOTLIKE(String val) {
        return !RIGHTLIKE(val);
    }

    @Override
    public boolean NOTMATCHES(String val) {
        return !MATCHES(val);
    }
   
}